package com.main;






//import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

//import javax.imageio.ImageIO;


import org.anddev.andengine.engine.Engine;
import org.anddev.andengine.engine.camera.ZoomCamera;
import org.anddev.andengine.engine.handler.IUpdateHandler;
import org.anddev.andengine.engine.options.EngineOptions;
import org.anddev.andengine.engine.options.EngineOptions.ScreenOrientation;
import org.anddev.andengine.engine.options.resolutionpolicy.RatioResolutionPolicy;
import org.anddev.andengine.entity.layer.tiled.tmx.TMXLayer;
import org.anddev.andengine.entity.layer.tiled.tmx.TMXTiledMap;
import org.anddev.andengine.entity.scene.Scene;
import org.anddev.andengine.entity.scene.Scene.IOnSceneTouchListener;
import org.anddev.andengine.entity.scene.background.ColorBackground;
import org.anddev.andengine.entity.util.FPSLogger;
import org.anddev.andengine.input.touch.TouchEvent;
import org.anddev.andengine.input.touch.detector.ScrollDetector;
import org.anddev.andengine.input.touch.detector.SurfaceScrollDetector;
import org.anddev.andengine.input.touch.detector.ScrollDetector.IScrollDetectorListener;
import org.anddev.andengine.ui.activity.BaseGameActivity;
import org.apache.sanselan.ImageReadException;
import org.apache.sanselan.Sanselan;
import org.apache.sanselan.common.IImageMetadata;


import org.anddev.andengine.engine.camera.Camera;
import org.anddev.andengine.entity.shape.Shape;
import org.anddev.andengine.entity.text.ChangeableText;

import org.anddev.andengine.extension.input.touch.controller.MultiTouch;
import org.anddev.andengine.extension.input.touch.controller.MultiTouchController;
import org.anddev.andengine.extension.input.touch.exception.MultiTouchException;
import org.anddev.andengine.opengl.font.Font;
import org.anddev.andengine.opengl.texture.Texture;
import org.anddev.andengine.opengl.texture.TextureOptions;
//import org.anddev.andengine.opengl.texture.bitmap.BitmapTextureAtlas;
//import org.anddev.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlasTextureRegionFactory;
import org.anddev.andengine.opengl.texture.region.TextureRegionFactory;



import com.commons.game_commons;
import com.commons.game_object;


import android.os.Environment;

public class main extends BaseGameActivity implements IScrollDetectorListener, IOnSceneTouchListener  {

	private ZoomCamera mCamera;
	private SurfaceScrollDetector mScrollDetector;
	private game_object obj1,obj2;
	
	// Definicion de objetos del motor AndEngine
	public Engine onLoadEngine() 
	{	
		
		this.mCamera = new ZoomCamera(0, 0, game_commons.cCamera_width , game_commons.cCamera_height );
		this.mCamera.setBounds(0, game_commons.cCamera_width, 0, game_commons.cCamera_height);
		this.mCamera.setBoundsEnabled(true);
		return new Engine(new EngineOptions(true, ScreenOrientation.LANDSCAPE, new RatioResolutionPolicy(game_commons.cCamera_width , game_commons.cCamera_height ), this.mCamera));
	}

	// Carga i asignacion de texturas i objetos.
	public void onLoadResources() {

		// Inicializamos la zona de status para mostrar msgs 
		game_commons.loadStatusArea(this.mEngine);
		
		// Creamos objetos de juego
		obj1 = new game_object(50, 50, game_commons.loadToSpriteMap("images/ui_ball.png", 0, 0, 2, 4, this),this,1,this.mEngine,128,256,2,4,"images/ui_ball.png");
		obj2 = new game_object(200, 100, game_commons.loadToSpriteMap("images/ui_player.png", 128, 0, 2, 4, this),this,1,this.mEngine,128,256,2,4,"images/ui_player.png");
			
		// Cargamos el sprite map
		this.mEngine.getTextureManager().loadTexture(game_commons.cSpriteMap );
	}

	public Scene onLoadScene() {
		
        this.mEngine.registerUpdateHandler(new FPSLogger());
		
		//*** Iniciamos escena ***//
        final Scene scene = new Scene(1);	
        
		// Asignamos color de fondo
        scene.setBackground(new ColorBackground(0, 0, 0.8784f));

        // *** CARGA DEL MAPA TMX ***//
        final TMXTiledMap mTMXTiledMap=game_commons.loadTMX(this, this.mEngine, "tmx/mapa.tmx");
        final TMXLayer tmxLayer = mTMXTiledMap.getTMXLayers().get(0);
        scene.getFirstChild().attachChild(tmxLayer);
        scene.setOnAreaTouchTraversalFrontToBack();
       
        // Aadimos manejador de Scroll
        this.mScrollDetector = new SurfaceScrollDetector(this);
        this.mScrollDetector.setEnabled(true);
        
        // Aadimos manejador de Touch de la pantalla
		scene.setOnSceneTouchListener(this);
		
		// Aadimos los objetos sensitivos al touch
		scene.registerTouchArea(obj1);
		scene.registerTouchArea(obj2);
		
		scene.setTouchAreaBindingEnabled(true);
			
		// Hacemos overrides para aadir funciones al bucle de juego (este se repite constantemente onUpdate) 
		scene.registerUpdateHandler(new IUpdateHandler() 
		{
			public void onUpdate(float pSecondsElapsed) {
				//game_commons.cStatus.setText("En pantalla x:"+ obj1.getX()); 
				
				// --------------------------------------------------------------------------------------------------
				// Antes de todo tenemos que conseguir el sprite actual de la animacion (tile_actual)
				
				//TiledSprite s1 = new TiledSprite();
				//game_commons.cStatus.setText(Integer.toString(obj1.getCurrentTileIndex()));
				//final Texture tempa= obj1.getTextureRegion().getTextureBuffer().getTextureRegion().getTexture();
				//				game_commons.cStatus.setText(Integer.toString(tempa.getWidth()));
				//Sprite gemPickup = new Sprite((int)obj1.oTiledTextureRegion.getTexturePositionOfCurrentTileX(),(int)obj1.oTiledTextureRegion.getTexturePositionOfCurrentTileY(), obj1.oTextureRegion);
				//(20, 20, 64, 64, this.tr1);
				//game_commons.cStatus.setText(Float.toString(gemPickup.getWidth()));
				
				/*
				// Necesario para colisiones transformadas
		        // punto_central de la textura
		        Me.origin = New Vector2((Me.texture.Width / 2), (Me.texture.Height / 2))
		        
				Dim obj_part_A_Transform As Matrix = 
			                Matrix.CreateTranslation(New Vector3(-obj_part_A.origin, 0.0F))
							* 
							Matrix.CreateRotationZ(obj_part_A.rotation)
							* 
							Matrix.CreateTranslation(New Vector3(obj_part_A.position, 0.0F))
		        
							obj1.
				// TEST PIXEL COLLISION
			    // Public textureData() As Color = Nothing
				// obj1.getWidth()/2 obj1.getHeight()/2
				// ReDim Me.textureData((Me.texture.Width * Me.texture.Height) - 1)
                // Me.texture.GetData(Me.textureData)
							
				final Matrix mtrxA= 
				//obj1.getWidth()/2,obj1.getHeight()/2
				Matrix.translate(32.0F,32.0F,0.0F) *
		        Matrix.rotationZ(obj1.rotation_angle) *
		        Matrix.translate(obj1.getX(),obj1.getY(),0.0F);
				*/
		        
		        // --------------------------------------------------------------------------------------------------
				
				//game_commons.cStatus.setText(game_commons.fv);
				
				
		        if (obj1.collidesWith(obj2))
				{
		        	game_commons.cStatus.setText("COLLISION");
				}
				else
				{
					game_commons.cStatus.setText("NO COLLISION");
				};

			}
			
			public void reset(){}
		});
		
		
        return scene;
	}


	public void onLoadComplete() 
	{
		// Aadimos todos los objetos en pantalla
		final Scene scene = this.mEngine.getScene();
		// Texto de estatus
		scene.getLastChild().attachChild(game_commons.cStatus);
		// Objetos de juego
		scene.getLastChild().attachChild(obj2);
		scene.getLastChild().attachChild(obj1);
		
		// Ordena por layers
		scene.getLastChild().sortChildren();
		
		
		// TEST AREA
		
		//*** TESTING
		
	
			/*
			javax.swing.JFrame f = null; 
			// Initialized elsewhere 
			// Create an image, and wait for it to load 
			Image i = new ImageIcon(Environment.getExternalStorageDirectory()+"/game/images/ui_ball.png").getImage();
			// Create a BufferedImage of the same size as the Image 
			BufferedImage bi = (BufferedImage)f.createImage(i.getWidth(f),i.getHeight(f)); 
			Graphics2D g = bi.createGraphics(); // Get a 
			g.drawImage(i, 0, 0, f); 
			// Draw the Image data into the BufferedImage
			*/
		   File f = new File(Environment.getExternalStorageDirectory()+"/game/images/ui_ball.png");
		   //if (f.exists()) game_commons.fv="existe";
		   //else game_commons.fv="no existe";
            
		
		/*
			IImageMetadata metadata = null;
			try {
					            metadata = Sanselan.getMetadata(new File(Environment.getExternalStorageDirectory()+"/game/images/ui_ball.png"));
					        } catch (ImageReadException e) {
					            e.printStackTrace();
					        } catch (IOException e) {
					            e.printStackTrace();
					        }
			*/
		
		
		   //BufferedImage image = ImageIO.read(new File(Environment.getExternalStorageDirectory()+"/game/images/ui_ball.png"));
		
			
	
				
				//AssetManager mgr = this.getResources().getAssets();
                //InputStream in = mgr.open("images/ui_ball.png");
				
                //Image g = ImageUtil.loadImage(in);
                
				 //Conversion C = new Conversion(); // invocamos clase
				 //Toolkit toolkit = Toolkit.getDefaultToolkit();

				 //int rgb;
				 //Image gen = toolkit.getImage("images/ui_ball.png");
			     //BufferedImage Nueva = C.toBufferedImage(gen);
				
				//InputStream in = getClass().getResourceAsStream("ui_ball.png");

				//BufferedImage bigImg = ImageIO.read(getClass().getResourceAsStream("ui_ball.png"));

                
				//BufferedImage bigImg = ImageIO.read(new File("images/ui_ball.png"));
				// The above line throws an checked IOException which must be caught.

				
				/*
				final int width = 10;
				final int height = 10;
				final int rows = 5;
				final int cols = 5;
				
				BufferedImage[] sprites = new BufferedImage[rows * cols];

				for (int i = 0; i < rows; i++)
				{
				    for (int j = 0; j < cols; j++)
				    {
				        sprites[(i * cols) + j] = bigImg.getSubimage(
				            i * width,
				            j * height,
				            width,
				            height
				        );
				    }
				}
				*/
	
				/*
				File img=new File();
				ImageIO.read(new File(img.getPath("pacman-sprites.png")));
				
                AssetManager mgr = this.getResources().getAssets();
                InputStream in = mgr.open("images/ui_ball.png");
    
                BufferedImage bi = ImageIO.read(isr);
*/
                


			
			
			
			
			/*
			
			BufferedImage bigImg = ImageIO.read(new File("sheet.png"));
			// The above line throws an checked IOException which must be caught.

			final int width = 10;
			final int height = 10;
			final int rows = 5;
			final int cols = 5;
			BufferedImage[] sprites = new BufferedImage[rows * cols];

			for (int i = 0; i < rows; i++)
			{
			    for (int j = 0; j < cols; j++)
			    {
			        sprites[(i * cols) + j] = bigImg.getSubimage(
			            i * width,
			            j * height,
			            width,
			            height
			        );
			    }
			}

			 */
		
		
		
		
		
		
		
	}

	// Evento que se desencadena al desplazar la pantalla???
	public void onScroll(ScrollDetector pScrollDetector, TouchEvent pTouchEvent,float pDistanceX, float pDistanceY) 
	{
		//Log.d(game_commons.cTag , "Scroll {x:" + pDistanceX + ", y: " + pDistanceY + "}");
	}
	
	// Evento que se desencadena al tocar la pantalla
	public boolean onSceneTouchEvent(Scene pScene, TouchEvent pSceneTouchEvent) 
	{
		//game_commons.cStatus.setText("En pantalla x:" + pSceneTouchEvent.getX() + ", y: " + pSceneTouchEvent.getY());
		//Log.d(game_commons.cTag , "En pantalla {x:" + pSceneTouchEvent.getX() + ", y: " + pSceneTouchEvent.getY() + "}");
		this.mScrollDetector.onTouchEvent(pSceneTouchEvent);
		return true;
	}	
	
	
	

	
}



/*
'*** Librerias de graficos Basicas ***

Imports Microsoft.Xna.Framework
Imports Microsoft.Xna.Framework.Graphics

Public Class cGame_Collisions


    Public Shared Function CheckCollisions(ByVal obj_part_A As cGame_Object, ByVal obj_part_B As cGame_Object) As Boolean

        '// *** PROCESSO PARA PLAYER
        '// Realizamos la transformada de la matriz del player a partir del punto de rotacion
        Dim obj_part_A_Transform As Matrix = Matrix.CreateTranslation(New Vector3(-obj_part_A.origin, 0.0F)) * Matrix.CreateRotationZ(obj_part_A.rotation) * Matrix.CreateTranslation(New Vector3(obj_part_A.position, 0.0F))
        '/ Matrix.CreateScale(obj_part_A.Escala) *  Si aplicamos escala hacemos...

        '// Calculamos el rectangulos preciso en funcion de los parametros del objeto
        Dim obj_part_A_Rectangle As Rectangle = cGame_Collisions.CalcularLimitesRectangulo(New Rectangle(0, 0, obj_part_A.texture.Width, obj_part_A.texture.Height), obj_part_A_Transform)

        '// *** PROCESSO PARA OTRO
        '// Realizamos la transformada de la matriz del player a partir del punto de rotacion
        Dim obj_part_B_Transform As Matrix = Matrix.CreateTranslation(New Vector3(-obj_part_B.origin, 0.0F)) * Matrix.CreateRotationZ(obj_part_B.rotation) * Matrix.CreateTranslation(New Vector3(obj_part_B.position, 0.0F))
        '/ Matrix.CreateScale(obj_part_B.Escala) *  Si aplicamos escala hacemos...

        '// Calculamos el rectangulos preciso en funcion de los parametros del objeto
        Dim obj_part_B_Rectangle As Rectangle = cGame_Collisions.CalcularLimitesRectangulo(New Rectangle(0, 0, obj_part_B.texture.Width, obj_part_B.texture.Height), obj_part_B_Transform)


        '**** NO podemos verificar cada vez la colision por pixel por que es un algoritmo que consume muchos recursos
        '**** Por lo tanto primero verficamos por rectangulo.

        If obj_part_A_Rectangle.Intersects(obj_part_B_Rectangle) Then
            If cGame_Collisions.DeteccionInterseccionPixels(obj_part_A_Transform, obj_part_A.texture.Width, obj_part_A.texture.Height, obj_part_A.textureData, obj_part_B_Transform, obj_part_B.texture.Width, obj_part_B.texture.Height, obj_part_B.textureData) Then
                Return True
            End If
        End If

        Return False

    End Function


    Public Shared Function DeteccionInterseccionPixels(ByVal transformA As Matrix, ByVal widthA As Integer, ByVal heightA As Integer, ByVal dataA() As Color, ByVal transformB As Matrix, ByVal widthB As Integer, ByVal heightB As Integer, ByVal dataB() As Color) As Boolean

        Dim transformAToB As Matrix = transformA * Matrix.Invert(transformB)
        Dim stepX As Vector2 = Vector2.TransformNormal(Vector2.UnitX, transformAToB)
        Dim stepY As Vector2 = Vector2.TransformNormal(Vector2.UnitY, transformAToB)

        Dim yPosInB As Vector2 = Vector2.Transform(Vector2.Zero, transformAToB)

        Dim yA As Integer, xA As Integer


        For yA = 0 To (heightA - 1)

            Dim posInB As Vector2 = yPosInB

            For xA = 0 To (widthA - 1)

                Dim xB As Integer = CInt(Math.Round(posInB.X))
                Dim yB As Integer = CInt(Math.Round(posInB.Y))

                If (0 <= xB And xB < widthB And 0 <= yB And yB < heightB) Then

                    Dim colorA As Color = dataA(xA + yA * widthA)
                    Dim colorB As Color = dataB(xB + yB * widthB)


                    If (colorA.A <> 0 And colorB.A <> 0) Then

                        Return True
                    End If
                End If

                posInB += stepX
            Next

            yPosInB += stepY
        Next

        Return False
    End Function

    Public Shared Function CalcularLimitesRectangulo(ByVal _rectangle As Rectangle, ByVal transform As Matrix) As Rectangle

        Dim leftTop As Vector2 = New Vector2(_rectangle.Left, _rectangle.Top)
        Dim rightTop As Vector2 = New Vector2(_rectangle.Right, _rectangle.Top)
        Dim leftBottom As Vector2 = New Vector2(_rectangle.Left, _rectangle.Bottom)
        Dim rightBottom As Vector2 = New Vector2(_rectangle.Right, _rectangle.Bottom)

        Vector2.Transform(leftTop, transform, leftTop)
        Vector2.Transform(rightTop, transform, rightTop)
        Vector2.Transform(leftBottom, transform, leftBottom)
        Vector2.Transform(rightBottom, transform, rightBottom)

        Dim min As Vector2 = Vector2.Min(Vector2.Min(leftTop, rightTop), Vector2.Min(leftBottom, rightBottom))
        Dim max As Vector2 = Vector2.Max(Vector2.Max(leftTop, rightTop), Vector2.Max(leftBottom, rightBottom))

        Return New Rectangle(CInt(min.X), CInt(min.Y), CInt(max.X - min.X), CInt(max.Y - min.Y))

    End Function
End Class


*/



/********************************************************************/
// COLLIOSION TEST 
/**********************************************************************/
//public void initialize_ASprite_System()
//{
	
/*
	 Image Imagen;
	 Conversion C = new Conversion(); // invocamos clase
	 Toolkit toolkit = Toolkit.getDefaultToolkit();

	 int rgb;
	 Imagen = toolkit.getImage("images/ui_ball.png");
     BufferedImage Nueva = C.toBufferedImage(Imagen);
*/
	    /*

	     rgb = 0xFF0000; // Asignamos color rojo

	    

	     for (int i = 0; i <= 100 ; i++) {

	        

	         Nueva.setRGB(i, i, rgb); // Escribimos Pixeles

	     }

	       

	  // Leemos algunos pixeles ....

	   System.out.println("Pix 1 = " + Nueva.getRGB(10,10));

	   System.out.println("Pix 2 = " + Nueva.getRGB(10,11));

	   System.out.println("Pix 3 = " + Nueva.getRGB(10,21));



	 // Convertimos la Imagen

	     g.drawImage(Nueva,0,0,this);

	
	
	
	
	
	*/
	
	
	
	
	
	
	
	//try {
	//Bitmap tgtImg = BitmapFactory.decodeFile("images/ui_ball.png");
	
	//AssetTextureSource ats = new AssetTextureSource(oactivity, "images/ui_ball.png");
	//Bitmap bmp = ats.onLoadBitmap();
	
    //ImageIcon icon = new ImageIcon("images/ui_ball.png");
    //Image image = icon.getImage();

    // Create empty BufferedImage, sized to Image
    //BufferedImage buffImage = new BufferedImage(image.getWidth(null), image.getHeight(null),BufferedImage.TYPE_INT_ARGB);

    // Draw Image into BufferedImage
    //Graphics g = buffImage.getGraphics();
    //g.drawImage(image, 0, 0, null);
    
/*
	}
    catch (Exception e) {
    	game_commons.fv="ERr";
    }
*/
	/*
		Bitmap image=null;
		BufferedImage loadImg=null;
		
		AssetTextureSource ats; // used to load the bitmap.
		ats = new AssetTextureSource(oactivity, "images/ui_ball.png");
		
		Bitmap bmp = ats.onLoadBitmap();
		if (bmp == null) 
		{
			game_commons.fv="NULL";
		}
		else
		{
			//game_commons.fv="NO NULL";
			
			int [] pixels = GLHelper.getPixels(bmp);
			image =Bitmap.createBitmap(pixels, oTilesWith, oTilesHeight, bmp.getConfig());
			
			ByteArrayOutputStream baos = new ByteArrayOutputStream();  
			image.compress(Bitmap.CompressFormat.PNG, 100, baos); //bm is the bitmap object   
			byte[] b = baos.toByteArray();  
			
			
			
			try {
				loadImg = bitmapToImage(b, "BMP");
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
			//BufferedImage loadImg = ImageUtil.loadImage(image); 
			
			//ImageData sourceData = new ImageData(x, y, 1, palette);
            //Image im = new Image(display, sourceData);


		}
		*/
	/*
		int rows = oTilesRow; //You should decide the values for rows and cols variables  
		int cols = oTilesColumn;  
		int chunks = rows * cols;  
		   
		int chunkWidth = image.getWidth() / cols; // determines the chunk width and height  
		int chunkHeight = image.getHeight() / rows; 
		
		int count = 0;

		BufferedImage imgs[] = new BufferedImage[chunks]; //Image array to hold image chunks  
		for (int x = 0; x < rows; x++) 
		{  
		     for (int y = 0; y < cols; y++) 
		     {  
		         //Initialize the image array with image chunks  
		    	 imgs[count] = new BufferedImage(chunkWidth, chunkHeight, BufferedImage.TYPE_INT_RGB);  
		    	 
		    	  // draws the image chunk  
		    	 Graphics2D gr = imgs[count].createGraphics();  
		    	 gr.drawImage(loadImg, 0, 0, chunkWidth, chunkHeight, chunkWidth * y, chunkHeight * x, chunkWidth * y + chunkWidth, chunkHeight * x + chunkHeight, null);  
		    	 gr.dispose();
		    	 
		    	 Raster ras = imgs[count].getData();
		    	 
		    	 DataBufferInt db = (DataBufferInt) ras.getDataBuffer();
		    	 
		    	 // Metemos el array de colores (int RGB) a un tipo vector.
		    	 this.oTileColorData[count]=new game_RGBColor(db.getData());
		    	 
		    	 game_commons.fv=Integer.toString(this.oTileColorData[count].Colors[6]);
		    	 
		    	 count++;
		     }  
		     
		}
		
		//System.out.println("Splitting done");     
*/
//}


//}		





	/*

	switch(pSceneTouchEvent.getAction()) {
	
	                                case TouchEvent.ACTION_DOWN:

	                                        Log.i("Card ZIndex", Integer.toString(this.getZIndex()));
	
	                                        //this.setZIndex(3);
	
	                                        this.setScale(1.25f);
	
	                                        this.mGrabbed = true;
	
	                                        //pScene.getTopLayer().sortEntities();
	
	                                               
	
	                                        MultiTouchExample.this.reZIndex(this.mIndex); // call the sort function
	
	                                        break;
	
	                                case TouchEvent.ACTION_MOVE:
	
	                                        if(this.mGrabbed) {
	
	                                                this.setPosition(pSceneTouchEvent.getX() - Card.CARD_WIDTH / 2, pSceneTouchEvent.getY() - Card.CARD_HEIGHT / 2);
	
	                                        }
	
	                                        break;
	
	                                case TouchEvent.ACTION_UP:
	
	                                        if(this.mGrabbed) {
	
	                                                this.mGrabbed = false;
	
	                                                this.setScale(1);
	
	                                                //this.reset();
	
	                                        }
	
	                                        break;
	
	                        }
*/









// CODIGO ANTIGUO PELOTA 
/*
// Cargamos los objetos al juego
for (int i=0;i<=3;i++){
	game_object tobj=new game_object(0,0,mPlayerTextureRegion,this,i);
	tobj.setTexture("images/ui_ball_1.png",this.mEngine);
	    game_commons.objects.add(tobj);
}
*/

// scene.registerTouchArea(sprite);

// CODIGO ANTIGUO PELOTA 
/*
for (game_object tobj : game_commons.objects) {
	// asignamos posicionamiento del objeto
    tobj.ox  = (game_commons.cCamera_width   - tobj.oFaceTextureRegion.getWidth()) / 2 + ii;
    tobj.oy = (game_commons.cCamera_height  - tobj.oFaceTextureRegion.getHeight()) / 2 + ii;
    // Pasamos el objeto a la pantalla
    scene.getLastChild().attachChild(new Sprite(tobj.ox, tobj.oy, tobj.oFaceTextureRegion));
    ii=ii+10;
}     
*/
